export type TBasicServerSideResult = {
    query: Record<string, any>;
    url: string;
    locales: string[];
    locale: string;
    headers: Record<string, any>[];
    host: string;
    resolvedUrl: string;
    protocal: string;
    domain: string;
    port?: string;
    solution: Record<string, any>;
    context: {
        city: string;
        country: string;
        countryName: string;
        region: string;
        regionName: string;
        latitude: string;
        longitude: string;
        metroCode: string;
        postalCode: string;
        timeZone: string;
        referer: string;
    };
    appTrack: boolean;
    cookies: any;
};
export declare const getBasicServerSideProps: (props: Record<string, any>) => Promise<TBasicServerSideResult>;
export declare const getRecordServerSideProps: (basicServerSideProps: TBasicServerSideResult, entityName: string, entityType?: string, includeList?: boolean, cacheExpireMinutes?: number) => Promise<Record<string, any>>;
export declare const returnServerSideProps: (props: Record<string, any>) => Record<string, any>;
