"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListHeaderSection = void 0;
var react_1 = __importStar(require("react"));
var search_1 = __importDefault(require("../search"));
var auth_call_api_1 = require("../../context/auth-call-api");
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var primeobjects_ui_web_store_1 = require("primeobjects-ui-web-store");
var mobx_react_lite_1 = require("mobx-react-lite");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var in_progress_1 = require("../../controls/in-progress");
var action_button_1 = __importDefault(require("../../controls/action-button"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var dropdown_1 = __importDefault(require("../../controls/antd/dropdown"));
var menu_1 = __importDefault(require("../../controls/antd/menu"));
var popover_1 = __importDefault(require("../../controls/antd/popover"));
var plainjs_1 = require("@json2csv/plainjs");
var lodash_1 = require("lodash");
var local_storage_1 = require("primeobjects-ui-web-basic/build/cjs/util/local-storage");
var solution_1 = require("primeobjects-helper-ui/build/cjs/hooks/solution");
var util_1 = require("../../util");
exports.ListHeaderSection = (0, mobx_react_lite_1.observer)(function (props) {
    var _a, _b;
    var entity = props.entity, cancelSearch = props.cancelSearch, showTags = props.showTags, hideSearchService = props.hideSearchService, queryResult = props.queryResult, apis = props.apis;
    var envStore = (0, primeobjects_ui_web_store_1.useEnvStore)();
    var envData = JSON.parse(envStore.data);
    var searching = (_a = envData === null || envData === void 0 ? void 0 : envData.search) === null || _a === void 0 ? void 0 : _a.doing;
    var primaryColor = (0, primeobjects_helper_ui_1.usePrimaryColor)();
    var solution = (0, solution_1.useSolution)();
    var createButtonText = props.createButtonText
        ? props.createButtonText
        : "New";
    var _c = (0, react_1.useState)(undefined), searchService = _c[0], setSearchService = _c[1];
    var hideCreateButton = entity.disableCreate == true ||
        props.hideCreateButton == true ||
        !props.onClickCreateButton;
    var exportProps = (_b = props.exportProps) !== null && _b !== void 0 ? _b : [
        "id",
        "display",
        "stateCode",
        "statusCode",
        "createdOn|datetime",
        "modifiedOn|datetime",
        "organizationId",
        "solutionId"
    ];
    var _d = (0, react_1.useState)(false), openCategories = _d[0], setOpenCategories = _d[1];
    var exportResult = (0, react_1.useRef)({
        count: 0,
        data: []
    });
    var exportQuery = (0, react_1.useRef)(undefined);
    var _e = (0, react_1.useState)(-1), exportCount = _e[0], setExportCount = _e[1];
    var abortController = (0, react_1.useRef)();
    var isExporting = exportCount >= 0;
    var query = queryResult === null || queryResult === void 0 ? void 0 : queryResult.query;
    var result = queryResult === null || queryResult === void 0 ? void 0 : queryResult.result;
    (0, react_1.useEffect)(function () {
        //check whether there is a local saved search service
        var localQueryService = (0, local_storage_1.getLocalStorage)("query-service-".concat(query === null || query === void 0 ? void 0 : query.entityName));
        setSearchService(hideSearchService
            ? "hidden"
            : (query === null || query === void 0 ? void 0 : query.service) != "hidden" && localQueryService
                ? localQueryService
                : (query === null || query === void 0 ? void 0 : query.service)
                    ? query === null || query === void 0 ? void 0 : query.service
                    : "auto");
    }, [query]);
    var onSubmitSearch = function (keywords) {
        props.onSubmitSearch && props.onSubmitSearch(keywords);
    };
    var onRefresh = function () {
        props.onRefresh && props.onRefresh();
    };
    var getPropValue = function (record, name) {
        if (!name || !(0, primeobjects_helper_util_1.isNonEmptyString)(name) || !record)
            return undefined;
        var layers = name.split(".");
        if (layers.length > 1) {
            var curName = layers.shift();
            if (curName) {
                var newRecord = record[curName];
                var newName = layers.join(".");
                return getPropValue(newRecord, newName);
            }
            else {
                return undefined;
            }
        }
        return record[name];
    };
    var onClickExport = function (all) {
        all ? onClickExportAll() : onClickExportCurrent();
    };
    var onClickExportAll = function () {
        try {
            if (query) {
                exportQuery.current = (0, lodash_1.cloneDeep)(query);
                exportQuery.current.name = "first";
                exportQuery.current.attributes = (0, lodash_1.uniq)((0, lodash_1.map)(exportProps, function (p) {
                    return p.split("|")[0].split(".")[0];
                })).join(",");
                exportQuery.current.pageNumber = 1;
                exportQuery.current.pageSize = 50;
                queryExportAll(0);
            }
        }
        catch (err) {
            console.error(err);
        }
    };
    var queryExportAll = function (count) {
        var _a;
        var apiEndpoint = apis
            ? (0, util_1.getApiEndpointBase)(apis, "data", "query")
            : (0, util_1.getApiEndpoint)(solution, "data", "query", entity === null || entity === void 0 ? void 0 : entity.entityName);
        if (apiEndpoint) {
            (_a = abortController.current) === null || _a === void 0 ? void 0 : _a.abort();
            abortController.current = new AbortController();
            console.log({ count: count });
            setExportCount(count);
            (0, auth_call_api_1.callApi)(solution, apiEndpoint, { query: exportQuery.current }, "post", {
                abortSignal: abortController.current.signal
            })
                .then(function (r) {
                var _a, _b;
                var newResult = { count: 0, data: [] };
                switch ((_a = exportQuery.current) === null || _a === void 0 ? void 0 : _a.name) {
                    case "more": {
                        newResult = {
                            count: exportResult.current.count + r.count,
                            continuation: r.continuation,
                            data: __spreadArray(__spreadArray([], exportResult.current.data, true), r.data, true)
                        };
                        break;
                    }
                    default: {
                        newResult = r;
                        break;
                    }
                }
                exportResult.current = newResult;
                if ((0, lodash_1.isNumber)(newResult.continuation) &&
                    ((_b = exportQuery.current) === null || _b === void 0 ? void 0 : _b.pageNumber)) {
                    exportQuery.current.name = "more";
                    exportQuery.current.pageNumber =
                        exportQuery.current.pageNumber + 1;
                    queryExportAll(newResult.count);
                }
                else {
                    setExportCount(-1);
                    exportData(newResult);
                }
            })
                .catch(function (ex) {
                console.error(ex);
                alert("Sorry, the export failed, please try again later.");
                setExportCount(-1);
                abortController.current = null;
            });
        }
    };
    var onClickExportCurrent = function () {
        exportData(result);
    };
    var exportData = function (result) {
        try {
            if (result) {
                var parser = new plainjs_1.Parser();
                var data = (0, lodash_1.map)(result === null || result === void 0 ? void 0 : result.data, function (r) {
                    var newR = {};
                    (0, lodash_1.each)(exportProps, function (fname) {
                        var nameType = fname.split("|");
                        var type = nameType.length > 1 ? nameType[1] : "";
                        var name = nameType[0];
                        switch (type) {
                            case "datetime": {
                                newR[fname] = new Date(getPropValue(r, name));
                                break;
                            }
                            default: {
                                newR[fname] = getPropValue(r, name);
                                break;
                            }
                        }
                        // if (
                        //     isNumber(v) &&
                        //     isDate(new Date(v)) &&
                        //     new Date(v).getTime() -
                        //         new Date("1971-1-1").getTime() >
                        //         0
                        // ) {
                        //     newR[fname] = new Date(v);
                        // } else {
                        //     newR[fname] = v;
                        // }
                    });
                    return newR;
                });
                var csv = parser.parse(data);
                var element = document.createElement("a");
                element.setAttribute("href", "data:text/plain;charset=utf-8," +
                    encodeURIComponent("".concat(csv)));
                element.setAttribute("download", "".concat(entity.entityName.toLowerCase()).concat(entity.entityType
                    ? "-".concat(entity.entityType.toLowerCase())
                    : "", "-").concat(Date.now(), ".csv"));
                element.style.display = "none";
                document.body.appendChild(element);
                element.click();
                document.body.removeChild(element);
            }
        }
        catch (err) {
            console.error(err);
        }
    };
    var onClickToggleTagsButton = function () {
        props.onClickToggleTagsButton && props.onClickToggleTagsButton();
    };
    var onClickFilterButton = function () { };
    var onClickCreateButton = function () {
        props.onClickCreateButton &&
            props.onClickCreateButton({
                id: (0, primeobjects_helper_util_1.newGuid)(),
                entityName: entity.entityName,
                entityType: entity.entityType
            });
    };
    var onClickSearchService = function (service) {
        (0, local_storage_1.setLocalStorage)("query-service-".concat(query === null || query === void 0 ? void 0 : query.entityName), service);
        setSearchService(service);
        props.onRefresh && props.onRefresh();
    };
    var renderCurrentSearchServiceName = function () {
        switch (searchService) {
            case "database": {
                return "Simple search engine";
            }
            case "elastic": {
                return "Full-text search engine";
            }
            default: {
                return "Auto search engine";
            }
        }
    };
    return (react_1.default.createElement("div", { className: "w-full flex flex-row py-4 items-center relative bg-white" },
        !props.hideEntityIcon && (react_1.default.createElement("div", { className: "flex ml-4" },
            react_1.default.createElement(svg_1.default, { src: entity.icon, size: 32, color: primeobjects_helper_util_1.COLORS.GRAY["900"] }))),
        props.onSubmitSearch &&
            !props.hideSearch &&
            (isExporting ? (react_1.default.createElement("div", { className: "w-full p-1" })) : (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(search_1.default, { searching: searching, onSubmit: onSubmitSearch, placeholder: entity.searchInputPlaceholder
                        ? entity.searchInputPlaceholder
                        : "Search ".concat(entity.uiCollectionName, " ..."), wrapperStyle: searchService == "hidden"
                        ? { height: 32 }
                        : { height: 20 }, wrapperClassName: searchService == "hidden" ? "px-2" : "px-2 pt-2", inputClassName: "max-w-xs", cancelSearch: cancelSearch }),
                searchService != "hidden" && (react_1.default.createElement("div", { className: "absolute cursor-pointer", style: { top: 8, left: 56 } },
                    react_1.default.createElement("div", { style: { width: 150 } },
                        react_1.default.createElement(dropdown_1.default, { trigger: ["click"], placement: "top", overlay: react_1.default.createElement(menu_1.default, null,
                                react_1.default.createElement(menu_1.default.Item, { onClick: function () {
                                        return onClickSearchService("auto");
                                    } }, "Auto search engine"),
                                react_1.default.createElement(menu_1.default.Item, { onClick: function () {
                                        return onClickSearchService("database");
                                    } }, "Simple search engine"),
                                react_1.default.createElement(menu_1.default.Item, { onClick: function () {
                                        return onClickSearchService("elastic");
                                    } }, "Full-text search engine")) },
                            react_1.default.createElement("div", { className: "w-full flex" },
                                react_1.default.createElement("div", { className: "text-xs" }, renderCurrentSearchServiceName()),
                                react_1.default.createElement(svg_1.default, { style: { margin: 4 }, src: "/icons/platform/down.svg", size: 10, color: primeobjects_helper_util_1.COLORS.GRAY["900"] }))))))))),
        react_1.default.createElement("div", { className: "flex mr-4" },
            props.hideCategoriesButton != true &&
                !isExporting &&
                props.renderCategories && (react_1.default.createElement(popover_1.default, { placement: "bottomRight", open: openCategories, onOpenChange: function (newOpen) {
                    setOpenCategories(newOpen);
                }, trigger: "click", content: react_1.default.createElement("div", { style: { width: 350 } }, props.renderCategories(function () {
                    setOpenCategories(false);
                })) },
                react_1.default.createElement(action_button_1.default, { id: "list-header-categories", iconSrc: "/icons/platform/categories.svg" }))),
            (exportProps === null || exportProps === void 0 ? void 0 : exportProps.length) > 0 &&
                !props.hideExportButton &&
                (isExporting ? (react_1.default.createElement("div", { className: "min-w-32 flex flex-row" },
                    react_1.default.createElement("div", { className: "min-w-18" },
                        react_1.default.createElement(in_progress_1.InProgress, { primaryColor: primeobjects_helper_util_1.COLORS.GRAY[700] })),
                    react_1.default.createElement("div", { className: "leading-none self-center w-full text-sm" }, "Exporting"),
                    exportCount > 0 && (react_1.default.createElement("div", { className: "ml-1 leading-none self-center w-full text-sm" }, exportCount < 1000
                        ? exportCount
                        : (0, primeobjects_helper_util_1.formatNumberBMK)(exportCount))))) : (react_1.default.createElement(dropdown_1.default, { trigger: ["click"], overlay: react_1.default.createElement(menu_1.default, null,
                        react_1.default.createElement(menu_1.default.Item, { key: "export-current", className: "w-full", onClick: function () {
                                onClickExport(false);
                            } },
                            react_1.default.createElement("span", null, "Export current records")),
                        react_1.default.createElement(menu_1.default.Item, { key: "export-all", className: "w-full", onClick: function () {
                                onClickExport(true);
                            } },
                            react_1.default.createElement("span", null, "Export all records"))), placement: "bottomLeft" },
                    react_1.default.createElement(action_button_1.default, { id: "list-header-export-csv", iconSrc: "/icons/platform/export-csv.svg" })))),
            props.onRefresh && !isExporting && (react_1.default.createElement(action_button_1.default, { id: "list-header-refresh", onClick: onRefresh, iconSrc: "/icons/platform/refresh.svg" })),
            props.onClickToggleTagsButton && !isExporting && (react_1.default.createElement(action_button_1.default, { id: "list-header-filter", onClick: onClickToggleTagsButton, iconSrc: "/icons/platform/tags.svg", tooltipText: "Toggle tags", iconColor: showTags ? primaryColor["600"] : undefined })),
            props.onClickFilterButton && !isExporting && (react_1.default.createElement(action_button_1.default, { id: "list-header-filter", onClick: onClickFilterButton, iconSrc: "/icons/platform/filter.svg" })),
            !hideCreateButton && !isExporting && (react_1.default.createElement(action_button_1.default, { id: "list-header-new", onClick: onClickCreateButton, wrapperClassName: "bg-green-500 hover:bg-green-600", text: createButtonText, textColor: primeobjects_helper_util_1.COLORS.WHITE })))));
});
exports.default = exports.ListHeaderSection;
//# sourceMappingURL=header.js.map