"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListNavSection = exports.LISTS_OPTION = exports.TAGS_OPTION = exports.CATEGORIES_OPTION = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var colors_1 = require("primeobjects-helper-util/build/cjs/colors");
var tooltip_1 = __importDefault(require("../../controls/antd/tooltip"));
var primary_color_1 = require("primeobjects-helper-ui/build/cjs/hooks/primary-color");
var svg_1 = require("primeobjects-ui-web-basic/build/cjs/controls/svg");
exports.CATEGORIES_OPTION = {
    tooltip: "Categories",
    iconSrc: "/icons/platform/categories.svg",
    id: "categories",
    entityName: "Category",
    attributeName: "categoryIds",
    type: "tree"
};
exports.TAGS_OPTION = {
    tooltip: "Tags",
    iconSrc: "/icons/platform/tags.svg",
    id: "tags",
    type: "tags"
};
exports.LISTS_OPTION = {
    tooltip: "Lists",
    iconSrc: "/icons/platform/tiles.svg",
    id: "lists",
    type: "lists"
};
var ListNavSection = function (props) {
    var showDrawer = props.showDrawer, smallScreen = props.smallScreen;
    var primaryColor = (0, primary_color_1.usePrimaryColor)();
    var _a = (0, react_1.useState)(false), close = _a[0], setClose = _a[1];
    var options = props.options && props.options.length > 0
        ? props.options
        : [exports.CATEGORIES_OPTION, exports.TAGS_OPTION, exports.LISTS_OPTION];
    var onToggleClose = function () {
        if (smallScreen)
            return;
        var newClose = !close;
        setClose(newClose);
        props.onToggleClose(newClose);
    };
    return (react_1.default.createElement("div", { className: "h-full max-h-full min-h-full flex bg-white flex-col overflow-hidden", style: __assign({ width: 60 }, props.wrapperStyle) },
        react_1.default.createElement(tooltip_1.default, { title: "Close drawer", color: primaryColor["400"], placement: "right", className: showDrawer ? "" : "hidden" },
            react_1.default.createElement("button", { className: "w-full p-1 border-b border-r", onClick: props.onCloseDrawer, style: { height: 65 } },
                react_1.default.createElement("div", { className: "w-full h-full px-3 py-4 bg-gray-50" },
                    react_1.default.createElement(svg_1.SVG, { src: "/icons/platform/x.svg", size: 26, color: colors_1.COLORS.GRAY["900"] })))),
        react_1.default.createElement(tooltip_1.default, { title: close ? "Open filter pane" : "Close filter pane", color: primaryColor["400"], placement: "right", className: showDrawer ? "hidden" : "" },
            react_1.default.createElement("button", { className: "w-full p-1 ".concat(close ? "" : "border-r", " border-b ").concat(smallScreen ? "cursor-not-allowed" : ""), onClick: onToggleClose, style: { height: 65 } },
                react_1.default.createElement("div", { className: "w-full h-full px-3 py-4 bg-gray-50 ".concat(smallScreen ? "" : "hover:shadow-lg") },
                    react_1.default.createElement(svg_1.SVG, { src: close
                            ? "/icons/platform/pane-right-arrow.svg"
                            : "/icons/platform/pane-left-arrow.svg", size: 26, color: !smallScreen
                            ? colors_1.COLORS.GRAY["900"]
                            : colors_1.COLORS.GRAY["300"] })))),
        !(0, lodash_1.isNil)(props.currentId) &&
            (0, lodash_1.map)(options, function (option, index) {
                var isCurTab = props.currentId == option.id;
                return (react_1.default.createElement(tooltip_1.default, { key: index, title: option.tooltip, color: option.disabled
                        ? colors_1.COLORS.GRAY["400"]
                        : primaryColor["400"], placement: "right" },
                    react_1.default.createElement("div", { className: "w-full pt-1 ".concat(isCurTab ? "py-1 pl-1" : "px-1 border-r", " ").concat(option.disabled
                            ? "cursor-not-allowed"
                            : "cursor-pointer"), onClick: option.disabled
                            ? function () { }
                            : function () { return props.onSelectOption(option); }, style: { height: 65 } },
                        react_1.default.createElement("div", { className: "w-full h-full px-3 py-4 ".concat(isCurTab
                                ? "border-".concat(primaryColor.name, "-400 border-l-4 shadow-lg")
                                : "bg-gray-50 hover:shadow-lg") },
                            react_1.default.createElement(svg_1.SVG, { src: option.iconSrc, size: 26, color: isCurTab
                                    ? primaryColor["600"]
                                    : colors_1.COLORS.GRAY["900"] })))));
            }),
        !close && react_1.default.createElement("div", { className: "flex-1 border-r" })));
};
exports.ListNavSection = ListNavSection;
exports.default = exports.ListNavSection;
//# sourceMappingURL=nav.js.map