"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeModal = void 0;
var react_1 = __importDefault(require("react"));
var plain_modal_1 = require("primeobjects-ui-web-basic/build/cjs/controls/plain-modal");
var util_1 = require("../../util");
var primeobjects_ui_web_store_1 = require("primeobjects-ui-web-store");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var lodash_1 = require("lodash");
var MeForm = undefined;
var MeModal = function (props) {
    if (!MeForm) {
        console.log("Get global components in /modals/me-modal.tsx");
        MeForm = (0, util_1.getGlobalComponent)("MeForm", props.Form);
    }
    var contextStore = (0, primeobjects_ui_web_store_1.useContextStore)();
    var context = JSON.parse(contextStore.data);
    var user = context.user, solution = context.solution;
    var entity = (0, primeobjects_helper_util_1.getEntity)(solution, "User");
    var show = props.show, onClickClose = props.onClickClose, title = props.title;
    return (react_1.default.createElement(plain_modal_1.PlainModal, { title: title !== null && title !== void 0 ? title : "User Profile", show: show, onClickClose: onClickClose, width: 700 }, !(0, lodash_1.isNil)(MeForm) && react_1.default.createElement(MeForm, { entity: entity, record: user })));
};
exports.MeModal = MeModal;
exports.default = exports.MeModal;
//# sourceMappingURL=me-modal.js.map