"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SolutionModal = void 0;
var react_1 = __importDefault(require("react"));
var plain_modal_1 = require("primeobjects-ui-web-basic/build/cjs/controls/plain-modal");
var util_1 = require("../../util");
var primeobjects_ui_web_store_1 = require("primeobjects-ui-web-store");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var lodash_1 = require("lodash");
var SolutionForm = undefined;
var SolutionModal = function (props) {
    if (!SolutionForm) {
        console.log("Get global components in /modals/solution-modal.tsx");
        SolutionForm = (0, util_1.getGlobalComponent)("SolutionForm", props.Form);
    }
    var contextStore = (0, primeobjects_ui_web_store_1.useContextStore)();
    var context = JSON.parse(contextStore.data);
    var solution = context.solution;
    var entity = (0, primeobjects_helper_util_1.getEntity)(solution, "Solution");
    var show = props.show, onClickClose = props.onClickClose, title = props.title;
    return (react_1.default.createElement(plain_modal_1.PlainModal, { title: title !== null && title !== void 0 ? title : "Solution Profile", show: show, onClickClose: onClickClose, width: 700 }, !(0, lodash_1.isNil)(SolutionForm) && (react_1.default.createElement(SolutionForm, { entity: entity, record: solution }))));
};
exports.SolutionModal = SolutionModal;
exports.default = exports.SolutionModal;
//# sourceMappingURL=solution-modal.js.map