"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteBreadcrumbSection = void 0;
var react_1 = __importDefault(require("react"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var lodash_1 = require("lodash");
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var primary_color_1 = require("primeobjects-helper-ui/build/cjs/hooks/primary-color");
var core_2 = require("primeobjects-helper-util/build/cjs/core");
var SiteBreadcrumbSection = function (props) {
    var pages = props.pages, solution = props.solution;
    var primaryColorName = (0, primary_color_1.usePrimaryColorName)(solution);
    var className = (0, core_1.isNonEmptyString)(props.className) ? props.className : "";
    var style = (0, core_1.isObject)(props.style) ? props.style : {};
    var onClick = function (page) {
        page.url &&
            (0, core_1.isNonEmptyString)(page.url) &&
            (0, core_2.getWindow)().location.replace(page.url);
    };
    return (react_1.default.createElement("div", { className: "flex w-full ".concat(className, " border-t mt-2 pt-2 border-dashed"), style: style },
        (0, lodash_1.map)(pages, function (page, index) {
            return (react_1.default.createElement("div", { key: index, className: "flex content-center items-center" },
                index > 0 && (react_1.default.createElement(svg_1.default, { src: "/icons/platform/forward.svg", size: 10, className: index == 0 ? "mr-2" : "mx-2" })),
                react_1.default.createElement("a", { className: "flex w-full text-sm content-center items-center text-gray-600 ".concat((0, core_1.isNonEmptyString)(page.url)
                        ? "hover:text-".concat(primaryColorName, "-600 cursor-pointer")
                        : ""), onClick: function () {
                        onClick(page);
                    } }, page.title)));
        }),
        react_1.default.createElement("div", { className: "flex-1" })));
};
exports.SiteBreadcrumbSection = SiteBreadcrumbSection;
exports.default = exports.SiteBreadcrumbSection;
//# sourceMappingURL=site-breadcrumb.js.map