import { CSSProperties } from "react";
import { TColor } from "primeobjects-helper-util/build/cjs/colors";
export type TFormCustomProps = {
    solution: Record<string, any>;
    user: Record<string, any>;
    organization: Record<string, any>;
    record: Record<string, any>;
    primaryColor: TColor;
    entity: Record<string, any>;
    version: number | string;
    disabled?: boolean;
    readOnly?: boolean;
    action?: string;
    wrapperClassName?: string;
    toRefreshForm: () => void;
    toChangeRecord: (record: Record<string, any>, settings?: {
        overwriteOriRecord?: boolean;
    }) => void;
    onAction: (name: string, data?: Record<string, any> | string | number) => void;
    onSuccessAPICall: (name: string, data?: any) => void;
    onErrorAPICall: (name: string, value?: any, data?: any) => void;
    onStartAPICall: (name: string, data?: any) => void;
    onFinishAPICall: (name: string, data?: any) => void;
    toSave?: () => void;
    onSave: (record: Record<string, any>) => void;
    onShow: (name: string, value: boolean | string, data?: any) => void;
    toShow: (name: string, data?: any) => boolean;
    onHide: (name: string, value: boolean | string, data?: any) => void;
    toHide: (name: string, data?: any) => boolean;
    getSuccess: (name: string) => any;
    onSuccess: (name: string, value?: any, data?: any) => void;
    isSuccess: (name: string, value?: any) => boolean;
    getError: (name: string) => any;
    onError: (name: string, value?: any, data?: any) => void;
    isError: (name: string, value?: any) => boolean;
    onDoing: (name: string, value?: any, data?: any) => void;
    isDoing: (name: string, value?: any) => boolean;
    getDoing: (name: string) => any;
};
export type TFormHeaderCustomButton = {
    text: string;
    onClick: () => void;
    wrapperClassName?: string;
    wrapperStyle?: CSSProperties;
    doing?: boolean;
    textColor?: string;
    textColorName?: string;
};
export type TOnPreSaveResult = {
    type: "error" | "success";
    reason?: "CHECK-REQUIRED-FIELDS" | "Other";
    record?: Record<string, any>;
};
export type TFormWrapperProps = {
    currentTab?: string;
    disabled?: boolean;
    refreshForm?: number;
    record?: Record<string, any>;
    action?: string;
    entity: Record<string, any>;
    hideRecordId?: boolean;
    hideActionButton?: boolean;
    hideSaveButton?: boolean;
    hideHeader?: boolean;
    toSave?: string | number;
    tabs?: (string | ((props: TFormCustomProps) => Record<string, any>))[];
    hideTabs?: boolean;
    requiredFields?: ((record: Record<string, any>) => string[]) | string[];
    onClickSave?: (record?: Record<string, any>) => Record<string, any> | undefined;
    onPreSave?: (record: Record<string, any>) => Promise<TOnPreSaveResult>;
    onSave?: (record: Record<string, any>) => void;
    onDelete?: (record: Record<string, any>) => void;
    onClone?: (record: Record<string, any>) => void;
    onDoing?: (name: string, value?: any, data?: Record<string, any>) => void;
    onError?: (name: string, value?: any, data?: Record<string, any>) => void;
    onSuccess?: (name: string, value?: any, data?: Record<string, any>) => void;
    onAction?: (name: string, data?: Record<string, any> | string | number) => void;
    getRecordDisplay?: (record: Record<string, any>) => string;
    onGoBack?: () => void;
    wrapperClassName?: string;
    customButton?: TFormHeaderCustomButton;
};
export type TFormSectionProps = {
    wrapperClassName?: string;
    wrapperStyle?: CSSProperties;
    formBodyClassName?: string;
    formBodyStyle?: CSSProperties;
    formWrapperClassName?: string;
    formWrapperStyle?: CSSProperties;
    Fields?: Record<string, any>;
    entity?: Record<string, any>;
    tabs: Record<string, any>[];
    refreshForm?: number | string;
    refreshRecord?: number | string;
    record?: Record<string, any>;
    syncOriRecord?: number | string;
    error?: string;
    disabled?: boolean;
    hideTabs?: boolean;
    customButton?: TFormHeaderCustomButton;
    hideRecordId?: boolean;
    hideActionButton?: boolean;
    hideSaveButton?: boolean;
    hideHeader?: boolean;
    currentTab?: string;
    inputSize?: "small" | "normal" | "medium" | "large";
    getRecordDisplay?: (record: Record<string, any>) => string;
    onPreSave?: (record: Record<string, any>) => Promise<TOnPreSaveResult>;
    onPostSave?: (record: Record<string, any>) => Promise<any>;
    requiredFields?: ((record: Record<string, any>) => string[]) | string[];
    onChange?: (newRecord: Record<string, any>, field?: Record<string, any>) => void;
    onCustomForm?: (form: Record<string, any>) => void;
    onSelectNavOption?: (option: string) => void;
    toSave?: number | string;
    onSave?: (record: Record<string, any>) => void;
    onClickSave?: (record: Record<string, any>) => Record<string, any> | undefined;
    onDelete?: (record: Record<string, any>) => void;
    onClone?: (record: Record<string, any>) => void;
    onError?: (name?: string, error?: any) => void;
    onDoing?: (name: string, value?: any) => void;
    onGoBack?: () => void;
};
