export type TPageHeadCSSListItem = {
    href: string;
    integrity?: string;
    crossOrigin?: string;
};
export type TPageHeadJSListItem = {
    src: string;
    integrity?: string;
    crossOrigin?: string;
};
export type TPageHeadProps = {
    noIndex?: boolean;
    type?: "article" | "music" | "video" | "website" | "article" | "book" | "profile";
    facebook?: {
        domainVerification?: string;
        name?: string;
        publishedOn?: Date;
    };
    host?: string;
    domain: string;
    port?: string;
    author?: string;
    keywords?: string;
    titleAppendSiteName?: boolean;
    image?: {
        url: string;
        width: number;
        height: number;
        alt?: string;
        type: "image/jpeg" | "image/webp" | "image/png";
    };
    title?: string;
    description?: string;
    url: string;
    canonical?: string;
    children?: any;
    jsList?: (string | TPageHeadJSListItem)[];
    cssList?: (string | TPageHeadCSSListItem)[];
    query?: Record<string, any>;
    locale?: string;
    locales?: string[];
    headers?: Record<string, any>;
    twitterSite?: string;
    twitterHandle?: string;
    noFollow?: boolean;
};
export declare const PageHead: (props: TPageHeadProps) => JSX.Element;
export default PageHead;
