//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React from "react";
import SVG from "primeobjects-ui-web-basic/build/cjs/controls/svg";
import GradientDiv from "primeobjects-ui-web-basic/build/cjs/controls/gradient-div";
import { observer } from "mobx-react-lite";
import { useContextStore } from "primeobjects-ui-web-store";
export var OrgNavItem = observer(function (props) {
    var isOrgAdmin = props.isOrgAdmin, size = props.size, supportResize = props.supportResize, primaryColor = props.primaryColor;
    var contextStore = useContextStore();
    var context = JSON.parse(contextStore.data);
    var organization = context.organization;
    var onClickOrg = function () {
        props.onClickOrg && props.onClickOrg();
    };
    return (React.createElement("div", { className: "flex-1 h-full p-1 ".concat(size == "sm" ? "" : "pl-3"), onClick: isOrgAdmin ? onClickOrg : function () { } },
        React.createElement("div", { className: "flex flex-1 h-full py-2 ".concat(size == "sm" ? "px-2" : "", " items-center justify-center leading-none ").concat(isOrgAdmin ? "cursor-pointer" : ""), style: { width: supportResize ? 152 : "100%" } },
            React.createElement("div", { className: "flex flex-col items-center", style: { width: 36 } },
                React.createElement(SVG, { size: 36, src: "/icons/app/organization.svg", color: primaryColor["500"] })),
            organization && size != "sm" && (React.createElement("div", { className: "flex flex-col w-full ml-3" },
                React.createElement("div", { className: "w-full text-xs text-gray-500" }, "Organization"),
                React.createElement("div", { className: "flex flex-row w-full" },
                    React.createElement(GradientDiv, { className: "w-full leading-5 font-medium text-base text-gray-800" }, organization.name)))))));
});
//# sourceMappingURL=org.js.map